<?php

/**
 * LazyestAdminFolder
 * Thanks to:
 * Denis Howlett <feedback@isocra.com> // WWW: http://www.isocra.com/ for Table drag and Drop
 * Stuart Langridge, http://www.kryogenix.org/days/2007/04/07/sorttable-v2-making-your-tables-even-more-sortable for Table Sorting script
 * 
 * @package Lazyest-Gallery  
 * @author Marcel Brinkkemper (lazyest@brimosoft.nl)
 * @copyright 2008-2010 Marcel Brinkkemper
 * @since 0.16.0
 * @access public
 */
class LazyestAdminFolder extends LazyestFolder {
  
  function LazyestAdminFolder( $path ) {
    $this->__construct( $path );
  }
  
  function __construct( $path ) {
    LazyestFolder::__construct( $path );
  }
  
  function manage() {  
    global $lg_gallery, $wp_roles;
    
    ?>
    <script type="text/javascript">        
    	function lg_disableBoxes() {
    	  jQuery('#rolesdiv').hide();
    		var theRoles = document.getElementById('check_roles');		
    		var theBoxes = theRoles.getElementsByTagName('input');			
    		for (var i=0; i<theBoxes.length; i++) theBoxes[i].setAttribute('disabled', 'disabled');
    	}
    	
    	function lg_enableBoxes() {
    	  jQuery('#rolesdiv').show();
    		var theRoles = document.getElementById('check_roles');		
    		var theBoxes = theRoles.getElementsByTagName('input');															
    		for (var i=0; i<theBoxes.length; i++) theBoxes[i].removeAttribute('disabled');
    	}
    
    	function lg_roles_change() {
    		var theCheckbox = document.getElementById('everyone_checkbox');	
    			
    		if ( theCheckbox.checked ) {
    			lg_enableBoxes();
    		} else {
    			lg_disableBoxes();
    		}			
      }
        
      jQuery(document).ready(function() {  
        if ( jQuery('#rolesdiv').length ) {  
          lg_roles_change();
        }
      }) ; 
    </script>    
    <div class="wrap">
      <div id="icon-upload" class="icon32"><br /></div>
      <h2><?php _e( 'Edit Lazyest Gallery Folder ', $lg_gallery->text_domain ); ?></h2>
      <table class="form-table">
        <tbody>
          <tr>
            <td>
              <a href="admin.php?page=lazyest-filemanager" title="<?php _e( 'Go back to Manage Gallery Structure', $lg_gallery->text_domain ); ?>" ><?php _e( 'Gallery',$lg_gallery->text_domain ); ?></a> /
    <?php
    $this->open();
    $this->load( 'thumbs' );
    $levels = explode('/', untrailingslashit( $this->curdir ) );
    $tlevel = '';
    for ( $i = 0; $i < count( $levels ) - 1; $i++ ) {
    	$tlevel .= trailingslashit( $levels[$i] );    
    	echo '<a title=\"' . __('Manage level up', $lg_gallery->text_domain) . '" href="admin.php?page=lazyest-filemanager&amp;folder=' . lg_nice_link( $tlevel ) . '" >' . $levels[$i] . '</a> / ';
    }
    echo "<strong>$levels[$i]</strong>\n";
    ?>
            </td>
            <td style="width:120px">
              <a class="preview button" href="<?php echo $this->uri(); ?>" target="_blank"><?php _e( 'View this Folder',$lg_gallery->text_domain ); ?></a>
            </td>
          </tr>
        </tbody>  
      </table>
      <form name="sort_images_form" id="sort_images_form" method="post" action="admin.php?page=lazyest-filemanager&amp;folder=<?php echo $this->curdir; ?>">
    <?php  
    if ( function_exists( 'wp_nonce_field' ) ) wp_nonce_field( 'lg_manage_folder' );
    ?> 
        <input type="hidden" name="manage_folder" value="<?php echo $this->curdir; ?>" />
          <div id="poststuff"><br />
            <div id="gallery_edit">
              <div id="titlediv" style="margin:0px">
                <h3><label for="title"><?php _e( 'Caption', $lg_gallery->text_domain ) ?></label></h3>
                <div id="titlewrap"><input type="text" id="title" name="folder_caption" value="<?php echo htmlspecialchars( $this->caption, ENT_QUOTES ); ?>" size="80" style="width:90%; font-size:1.7em;" /></div>
                <div class="inside"><div id="edit-slug-box">
                  <strong>Permalink: </strong><?php echo $this->uri(); ?>
                </div></div>
              </div>
            <input type="hidden" name="directory" value="<?php echo $this->curdir; ?>"/>
            <div>
              <table class="form-table">
                <tbody>
                  <tr valign="top">
                    <td style="width:340px;">
    <?php                   
    $everyone = in_array( 'everyone', $this->roles );
    ?>              
                      <label><input id="everyone_checkbox" type="checkbox" name="everyone_checkbox" value="everyone" onclick="lg_roles_change()" <?php if ( $everyone === false ) echo 'checked="checked"'; ?> /><?php _e( 'User should be logged on to view this folder', $lg_gallery->text_domain ) ?></label>  
                    </td>
                    <td id="check_roles" style="text-align:left">
                      <div id="rolesdiv">
    <?php
    _e( 'Check roles allowed to view this folder', $lg_gallery->text_domain ) . '<br />';  
    foreach( $wp_roles->role_names as $role => $name ) {
    	$thename = translate_with_context( $name );
    	if ( in_array( $role, $this->roles ) ) {
    		$p .= "\n\t<label><input type=\"checkbox\" checked=\"checked\" value=\"$role\" name=\"chk_$role\" ";
    		if ( $everyone ) $p .= ' disabled="disabled"';
    		$p .= " />$name</label><br />";
    	}	else {
    		$p .= "\n\t<label><input type=\"checkbox\" value=\"$role\" name=\"chk_$role\" ";
    		if ( $everyone ) $p .= ' disabled="disabled"';
    		$p .= " />$name</label><br />\n";
    	}
    }
    echo $p;
    ?>
                      </div>
                    </td>
                    <td style="text-align:left">
                      <label class="selectit" for="visible_checkbox"><input id="visible_checkbox" type="checkbox" name="visible_checkbox" value="<?php echo $this->visibility; ?>"<?php checked( 'hidden', $this->visibility ); ?> /><?php _e('Hide this folder', $lg_gallery->text_domain ); ?></label>
                    </td>
                    <td style="width:80px;">
    <?php	
    if ( $this->can_save() ) {
    ?>
                      <input type="submit" class="button button-highlighted button-primary" name="update_folder" value="<?php _e('Update Folder', $lg_gallery->text_domain ); ?>" />
    
                  
    <?php
    }
    ?>
                    </td>
                    <td style="width:90px;">
    <?php                  
  	if ( $this->can_save() ) {
  	?>
                      <a onclick="if ( confirm('<?php echo __( 'You are about to delete this folder and all contents', $lg_gallery->text_domain); ?> \'<?php echo htmlspecialchars( $this->curdir, ENT_QUOTES); ?>\'\n  \'<?php _e('Cancel', $lg_gallery->text_domain); ?>\'<?php _e(' to stop, '); ?> \'OK\'<?php _e(' to delete.'); ?>') ) { return true;}return false;"  style="color:red" class="submitdelete deletion" href="admin.php?page=lazyest-filemanager&amp;delete_folder=<?php echo $this->curdir; ?>"><?php _e( 'Delete folder',$lg_gallery->text_domain ) ?></a>
    <?php 
  	}
    ?> 
                    </td>
                  </tr>
                </tbody>
              </table>
              <br /><br class='clear' />              
              <div id="folder_description" class="postbox " >
                <div class="handlediv"><br /></div><h3 class='hndle'><span>Description</span></h3>
                <div class="inside">
                  <label class="screen-reader-text" for="fdescription">Description</label><textarea rows="1" cols="80" name="fdescription" id="fdescription"><?php echo htmlspecialchars( stripslashes( $this->description ), ENT_QUOTES ); ?></textarea>
                </div>
              </div>
    <?php
    if ( 0 != count( $this->list ) ) {
      $this->manage_images();
    }  
  	if ( ( 7 < count( $this->list ) ) && $this->can_save() )  {
  	?> 
  		        <table class="form-table">
                <tbody>
                  <tr>
                    <td></td>
                    <td style="width:80px;">
                      <input type="submit" class="button button-highlighted button-primary" name="update_folder-s" value="<?php _e( 'Update Folder',$lg_gallery->text_domain ); ?>" />
                    </td>
                  </tr>
                </tbody>
              </table>
              <br class="clear" />
    <?php
  	}
  	?>
            </div>
          </div>
          <br class="clear" />
        </div>
      </form>
    </div>
    <?php
    if ( $this->can_save() ) {
      $this->uploader();
  	}
    $this->manage_subfolders();
    if ( $this->can_save() ) {
      $this->add_folder();
      $this->manage_advanced();
    } 
  }
  
  function manage_images() {
  	global $lg_gallery;
    
    ?>
    <script type="text/javascript">
      jQuery(document).ready(function() {
        jQuery('.descdiv').each( function() {
          jQuery(this).find('.button-secondary').css({display:'none'});
          if ( jQuery(this).children('textarea').html() != '' ) {
            jQuery(this).show();
          }
        }); 
      });
      
      function lg_edit_description( formName, Done ) {
        var anID = 'descdiv_' + formName;
        jQuery('.descdiv').each( function() { /* somehow JQuery cannot find the divs */
          if ( jQuery(this).attr('id') == anID ) {
            if (!Done) {
              jQuery(this).show('slow');
              jQuery(this).children('textarea').animate({height: '200px'},500 );
              jQuery(this).children('textarea').removeAttr('readonly');
              jQuery(this).children('textarea').css({overflow:'auto'});            
              jQuery(this).find('.button-secondary').css({display:'inline-block'});
            } else {
              if ( jQuery(this).children('textarea').html() == '' ) {
               jQuery(this).slideUp();
              } else {
                jQuery(this).children('textarea').animate({height: '64px'},500 );
                jQuery(this).children('textarea').attr({readonly: 'true'});              
                jQuery(this).children('textarea').css({overflow:'hidden'});              
                jQuery(this).find('.button-secondary').css({display:'none'});
              }
            }
          }
        });    
      }
    </script>
    <?php
    
    $this->load( 'thumbs' );  
    $sortit = ( 'MANUAL' == $lg_gallery->get_option( 'sort_alphabetically' ) ) && $this->can_save();
  	if ( 0 < count( $this->list ) ) { 
 	  ?>
  		<input type="hidden" name="manage_images" value="<?php echo $this->curdir; ?>" />
  		<table class="widefat<?php if ( $sortit )  echo " sortable"; ?>" id="sort_images" style="clear:none;">
  		  <thead>
          <tr>
  		      <th scope="col" class="unsortable"><?php echo __('Image', $lg_gallery->text_domain); ?></th>
  		      <th scope="col" style="cursor:default" title="<?php if ( $sortit ) _e( 'Click to Sort', $lg_gallery->text_domain); ?>"><?php echo __('File', $lg_gallery->text_domain); ?></th>
  		      <th scope="col" class="sorttable_alpha column-caption" style="cursor:default" title="<?php if ( $sortit ) _e( 'Click to Sort', $lg_gallery->text_domain); ?>"><?php echo __('Caption', $lg_gallery->text_domain); ?></th>
  		      <th scope="col" style="cursor:default" title="<?php if ( $sortit ) _e( 'Click to Sort', $lg_gallery->text_domain); ?>"><?php echo __('Date', $lg_gallery->text_domain); ?></th>
    <?php if ( 'TRUE' == $lg_gallery->get_option( 'allow_comments' ) ) { 
    ?>
            <th scope="col" class="num unsortable"><div class="vers"><img alt="<?php echo __( 'Comments', $lg_gallery->text_domain ); ?>" src="images/comment-grey-bubble.png"/></div></th> 
  	<?php	} 
    ?>		      
          </tr>
        </thead>
  		  <tbody id="image_list">
  	<?php	
  		for ( $i = 0; $i != count( $this->list ); $i++ ) {
  		  $image = $this->list[$i];
        $onclick = $image->on_click();
        $form_name = $image->form_name();
     ?>
  		  <tr>
  		    <td class="column-icon media-icon" width="80">
  	       <a target="_blank" href="<?php echo $onclick['href']; ?>" rel="<?php echo $onclick['rel'] ?>" class="alignleft<?php echo $onclick['class'] ?>"> 
  			     <img width="60" height="60" class="attachment-80x60" src="<?php echo $image->src(); ?>" alt="<?php echo $image->alt(); ?>"  title="<?php echo $image->title() ?>" />
            </a>
          </td>
          <td class="media column-media" sorttable_customkey="<?php echo $form_name; ?>">
            <p><strong><?php echo htmlspecialchars( $image->image, ENT_QUOTES); ?></strong></p>
            <input type="hidden" class="_index" id="index_<?php echo $form_name; ?>" name="index_<?php echo $form_name; ?>" value="<?php	echo $i+1; ?>" />
            <div class="row-actions">
      <?php
            if ( $this->can_save() ) {
      ?>
            <span class="edit">
              <a href="javascript:lg_edit_description('<?php echo $form_name; ?>', false)" ><?php _e('Edit'); ?></a>
            |</span>
            <span class="delete"><a class="submitdelete" 
            onclick="if ( confirm('<?php echo __( 'You are about to delete this image', $lg_gallery->text_domain); ?> \'<?php echo htmlspecialchars( $image->image, ENT_QUOTES); ?>\'\n  \'<?php _e('Cancel', $lg_gallery->text_domain); ?>\'<?php _e(' to stop, '); ?> \'OK\'<?php _e(' to delete.'); ?>') ) { return true;}return false;" 
            href="admin.php?page=lazyest-filemanager&amp;folder=<?php echo $this->curdir; ?>&amp;file_to_delete=<?php echo lg_nice_link( $image->image ); ?>" ><?php _e( 'Delete Permanently', $lg_gallery->text_domain ); ?></a>
            |</span>
      <?php         
        }
      ?>
            <span class="view">
              <a title="<?php echo __('View ', $lg_gallery->text_domain) . htmlspecialchars('"' . $image->image . '"', ENT_QUOTES); ?>" target="_blank" href="<?php echo $onclick['href'] ?>"  rel="<?php echo $onclick['rel'] ?>" class="<?php echo $onclick['class'] ?>"><?php echo __('View ', $lg_gallery->text_domain); ?></a> 
            </span>          
          </div>
      
          </td>
      <?php
  			$caption = htmlspecialchars( stripslashes( $image->caption ), ENT_QUOTES );
        $description = htmlspecialchars( stripslashes( $image->description ), ENT_QUOTES );
      ?>			 
          <td class="column-caption" sorttable_customkey="<?php echo $caption; ?>"><a name="<?php echo $form_name; ?>"></a>
      <?php
  			$tabstop = $i+2;
      ?>
            <input class="caption-text" type="text" tabindex="<?php echo $tabstop; ?>" name="<?php echo $form_name; ?>" value="<?php echo $caption; ?>" size="50" <?php if ( !$this->can_save() ) echo 'readonly="readonly"'; ?> />
            <div id="descdiv_<?php echo $form_name; ?>" class="descdiv"> 
            <strong><?php _e('Description');?></strong><br />                       
            <textarea class="desc codepress" name="desc_<?php echo $form_name; ?>" id="desc_<?php echo $form_name; ?>" readonly="readonly" tabindex="<?php echo $tabstop + 1; ?>" cols="50" ><?php echo $description; ?></textarea>
            <p><a class="button-secondary" href="javascript:lg_edit_description('<?php echo $form_name; ?>', true)" ><?php _e('Done'); ?></a></p>
            </div>
          </td>
          <td sorttable_customkey="<?php echo $image->datetime; ?>"><?php echo date( get_option( date_format ), $image->datetime ); ?>
          </td>
      <?php
  			if ( 'TRUE' == $lg_gallery->get_option( 'allow_comments' ) ) {
  				$comment_count = $lg_gallery->commentor->count_comments( $image->id ); 
      ?>
  				<td class="num">
            <div class="post-com-count-wrapper">
              <a class="post-com-count" href="admin.php?page=lazyest-filemanager&amp;edit=comments&amp;file=<?php echo $this->curdir . $image->image; ?>"><span class="comment-count"><?php echo $comment_count; ?></span></a>
            </div>
          </td>
      <?php
  			}
     ?>
          <td>
     
          </td>
        </tr>
     <?php			
  		}
     ?> 
  		  </tbody>
      </table>
      <?php
  		if ( ( 'MANUAL' == $lg_gallery->get_option( 'sort_alphabetically' ) ) && $this->can_save() ) {
  		?>  
  			<script type='text/javascript'>
          var sort_images = document.getElementById('sort_images');
          var imagesDnD = new TableDnD();
          imagesDnD.init(sort_images);
        </script>
      <?php      
  		}  
  	}    
  }
  
  function manage_subfolders() {
	global $lg_gallery;
  	
  	$folders = $this->subfolders();
  
  	if ( '' == $capdir ) {
  		$sort_title = __('Folders', $lg_gallery->text_domain); 
  	} else {
  		$sort_title = __('Sub Folders', $lg_gallery->text_domain); 
  	}
  	
  	if ( 0 != count( $folders ) ) {
  		$can_save = true;
  		for ( $i = 0; $i != count( $folders ); $i++ ) {
  		  $subfolder = $folders[$i];
  			if ( !$subfolder->can_save() ) $can_save = false;
  		}
      $sortit = ( 'MANUAL' == $lg_gallery->get_option( 'sort_alphabetically' ) ) && $can_save;
      ?>
  		<div class="wrap">
        <br class="clear" />
        <h2><?php _e( 'Sort Sub Folders', $lg_gallery->text_domain ); ?></h2>
  		  <form name="sort_gallery_form" method="post" id="sort_gallery_form" action="admin.php?page=lazyest-filemanager&amp;folder=<?php echo lg_nice_link( $this->curdir ); ?>" >
  		    <div class="tablenav">
      <?php    
  		if ( $can_save ) {
  		?>  
            <input style="margin:6px" class="button-secondary" name="sort_gallery_structure" type="submit" value="<?php _e( 'Save Gallery Order', $lg_gallery->text_domain ); ?>" />
      <?php      
  		}
      ?>
          </div>
          <br class="clear" />
      <?php          		
  		if ( function_exists("wp_nonce_field") ) wp_nonce_field("lg_sort_gallery_structure");
      ?> 
          <input type="hidden" name="sort_folders" value="<?php echo $this->curdir ?>" />
            <table class="widefat sortable" id="sort_gallery">
              <thead>
                <tr>
                  <th style="cursor:default" scope="col" title="<?php if ( $sortit ) _e( 'Click to Sort', $this->text_domain); ?>"><?php _e( 'Name', $lg_gallery->text_domain ); ?></th>
                  <th style="cursor:default" scope="col" title="<?php if ( $sortit ) _e( 'Click to Sort', $this->text_domain); ?>"><?php _e( 'Caption', $lg_gallery->text_domain ); ?></th>
                  <th style="cursor:default" scope="col" title="<?php if ( $sortit ) _e( 'Click to Sort', $this->text_domain); ?>"><?php _e( 'Date',  $lg_gallery->text_domain ); ?></th>
                  <th scope="col" class="sorttable_nosort"><?php _e( 'Hidden', $lg_gallery->text_domain ); ?></th>
                  <th scope="col" class="num sorttable_nosort"><?php _e( 'Images', $lg_gallery->text_domain ); ?></th>
                </tr>
              </thead>
              <tbody id="structure_list" class="list:gal">
  		<?php
  		for ( $i = 0; $i != count( $folders ); $i++) {
        $subfolder = $folders[$i];
		  ?>
                <tr title="<?php if ( $sortit ) _e( 'Drag and Drop to Rearrange', $this->text_domain); ?>">
                  <td sorttable_customkey="<?php echo strtolower( esc_attr( $subfolder->dirname() ) ) ?>">
                    <a title="<?php echo __( 'Edit' ) . ' &quot;' . $subfolder->dirname() . '&quot;'; ?>" class="row-title" href="admin.php?page=lazyest-filemanager&amp;folder=<?php echo lg_nice_link( $subfolder->curdir ); ?>"><?php echo $subfolder->curdir; ?></a>
                    <input type="hidden" class="_index" id="index_<?php echo $subfolder->form_name(); ?>" name="index_<?php echo $subfolder->form_name(); ?>" value="<?php echo $i+1; ?>" />
                  </td>
                  <td sorttable_customkey="<?php echo esc_attr( strtolower( $subfolder->title() ) ); ?>">
                    <?php echo $subfolder->title(); ?>
                  </td>
                  <td sorttable_customkey="<?php echo $subfolder->datetime; ?>"><?php echo date( get_option( date_format ), $subfolder->datetime ); ?></td>
                  <td>
                    <input style="cursor:default" type="checkbox" name="visible_<?php echo $subfolder->form_name(); ?>" value="hidden" <?php checked( 'hidden', $subfolder->visibility ); ?> />
                  </td>
                  <td class="num"><?php echo $subfolder->count(); ?></td>
                </tr>
      <?php                			
  		}
  		?>
              </tbody>
            </table>
      <?php            
  		if (count($folders) > 7) {
		  ?>
          <div class="tablenav">
            <input class="button-secondary" name="sort_gallery_structure-s" type="submit" value="<?php _e( 'Save Gallery Order', $lg_gallery->text_domain ); ?>" />
          </div>
          <br class="clear" />
      <?php		
  		} else {
		  ?>
          <div class="tablenav"></div>
          <br class="clear" />
        </form>
      </div>
      <?php
  		}
      ?>
  		<script type="text/javascript">
        var sort_gallery = document.getElementById("sort_gallery");
        var foldersDnD = new TableDnD();
        foldersDnD.init(sort_gallery);
      </script>
      <?php
  	}    
  }
  
  function manage_advanced() {
  	global $lg_gallery;
  
  	if ( ( 'TRUE' == $lg_gallery->get_option( 'enable_cache' ) ) || ( 'TRUE' == $lg_gallery->get_option( 'enable_slides_cache' ) ) ) {
    ?>
  	<div class="wrap">
      <h2><?php  _e('Advanced', $lg_gallery->text_domain ); ?></h2>
  		<table class="form-table">
        <tbody>
          <tr>
            <th scope="row"><strong><?php _e('Clear Cache', $lg_gallery->text_domain ); ?></strong></th>
      <?php            
  		if ( 'TRUE' == $lg_gallery->get_option( 'enable_cache' ) ) {
		  ?>
  		      <td>
              <a class="button-secondary" href="admin.php?page=lazyest-filemanager&amp;folder=<?php echo $this->curdir; ?>&amp;file_to_delete=<?php echo $lg_gallery->get_option( 'thumb_folder' ) ; ?>&amp;cache=thumbs" style="display:inline;"><?php _e('Empty Thumbs Cache', $lg_gallery->text_domain ); ?></a>
            </td>
  		
      <?php
      }
  		if ( 'TRUE' == $lg_gallery->get_option( 'enable_slides_cache' ) ) { // hier
      ?>
  		      <td>
              <a class="button-secondary" href="admin.php?page=lazyest-filemanager&amp;folder=<?php echo $this->curdir; ?>&amp;file_to_delete=<?php echo $lg_gallery->get_option("slide_folder"); ?>&amp;cache=slides" style="display:inline;"><?php _e( 'Empty Slides Cache', $lg_gallery->text_domain ); ?></a>
            </td>
      <?php
  		}
      ?>
  		      <td>
              <?php _e( 'This will delete the files stored in your cache.', $lg_gallery->text_domain ) ?>
            </td>
          </tr>
        </tbody>
      </table>
      <br class="clear" />
    <?php	
  	}    
  }
  
  function add_folder() {
    global $lg_gallery;
    ?>
  	   <div class="wrap">
        <br class="clear" />
        <h2><?php _e( 'New Folder', $lg_gallery->text_domain ); ?></h2>
        <form name="new_folder" id="new_folder" method="post" action="admin.php?page=lazyest-filemanager&amp;folder=<?php echo lg_nice_link( $this->curdir ); ?>">
    <?php	if ( function_exists( 'wp_nonce_field' ) ) wp_nonce_field( 'lg_add_folder' ); ?>
          <table class="form-table">
            <tbody>
              <tr class="form-field form-required">
                <th scope="row" valign="top"><label for="new_folder_name"><?php _e( 'Folder Name', $lg_gallery->text_domain ); ?></label></th>
                <td>
                  <input type="text" name="new_folder_name" id="new_folder_name" style="width:90%" /><br />
                  <input type="submit" style="width:128px" class="button" name="create_new_folder" value="<?php _e( 'New Folder', $lg_gallery->text_domain ); ?>" />
                </td>
              </tr>
            </tbody>
          </table>
        </form>
      </div>
      <br class="clear" />
    <?php
  }
  
  function uploader() {      
  	global $lg_gallery;
  		
  	$filetypes = '*.' . str_replace( ' ', ';*.', strtolower( $lg_gallery->get_option( 'fileupload_allowedtypes' ) ) );
    $allowed_types = explode(' ', trim( strtolower( $lg_gallery->get_option( 'fileupload_allowedtypes' ) ) ) );
    foreach ($allowed_types as $type) {
  		$type_tags[] = "<code>$type</code>";
  	}
  	$i = implode(', ', $type_tags);
    ?>    
      <br class="clear" />
      <div class="wrap">
        <h2><?php _e( 'Upload Image', $lg_gallery->text_domain ); ?></h2>          
          <div id="html_upload-ui">
            <a name="html_upload-ui"></a>
            <form action="<?php echo esc_attr( 'admin.php?page=lazyest-filemanager&amp;upload=html&amp;folder=' . lg_nice_link( $this->curdir ) ); ?>"  method="post" enctype="multipart/form-data">
             <?php	if ( function_exists('wp_nonce_field') ) wp_nonce_field('lg_upload_images'); ?> 
            <table class="form-table">
              <tbody>
                <tr class="form-field form-required">
                  <th><label for="html_upload"><?php _e( 'Image', $lg_gallery->text_domain ); ?></label></th>
                  <td>                    
                    <input type="hidden" name="MAX_FILE_SIZE" value="<?echo wp_max_upload_size(); ?>" />
                    <input type="file" name="html_upload" id="html_upload" size="60" />
                    <input type="hidden" name="upload_folder" value="<?php echo $this->curdir; ?>" /><br />
                    <?php echo __( 'You can upload files with the extensions ', $lg_gallery->text_domain )  . $i . __( ' as long as they are no larger than ', $lg_gallery->text_domain ) . $lg_gallery->get_option( 'fileupload_maxk' ); ?><abbr title="kilobytes">KB</abbr><br />
                    <p><input style="width:128px" type="submit" name="upload" class="button" value="<?php _e( 'Upload Image', $lg_gallery->text_domain ); ?>" /></p>
                  </td>
                </tr>
              </tbody>
            </table>
          </form>
        </div>
      </div>
    <?php 
  }
  
  function uploadfiles() {
    global $lg_gallery;	
  	$allowed_types = explode(' ', trim( strtolower( $lg_gallery->get_option( 'fileupload_allowedtypes' ) ) ) );  
  
    if ( !$this->can_save() ) {
      $lg_gallery->options_message( sprintf( __( "It doesn't look like you can use the file upload feature at this time because the directory you have specified (<code>%s</code>) doesn't appear to be writable by WordPress. Check the permissions on the directory and for typos.", $lg_gallery->text_domain), $folder), false );
      return;     
    }
    $newname = basename( ( isset( $_POST['newname'] ) ) ? $_POST['newname'] : '' );
    $image_name = ( strlen( $newname ) ) ? $newname : basename( $_FILES['html_upload']['name'] );
		$image_name = preg_replace( '/[^a-z0-9_.]/i', '', $image_name );
		$image_size = $_POST['newsize'] ? intval($_POST['newsize']) : intval($_FILES['html_upload']['size']);
		$image_type = ( strlen( $newname ) ) ? $_POST['newtype'] : $_FILES['html_upload']['type'];
		$path = pathinfo( $image_name );
		$imgtype = strtolower( $path['extension'] );

		if ( !in_array( $imgtype, $allowed_types ) ) {
		  $lg_gallery->options_message( sprintf( __( 'File %s of type %s is not allowed', $lg_gallery->text_domain ), $image_name, $image_type ) );
      return;      
    }	    
		$pathtofile = trailingslashit( $lg_gallery->root . $this->curdir ) . $image_name;
    $html_upload = ( strlen( $newname ) ) ? $_POST['html_upload'] : $_FILES['html_upload']['tmp_name'];
		$i = 1;
    $checkname = $pathtofile;
    $duplicate_file = false;
		while ( file_exists( $checkname ) ) {
		  $duplicate_file = true;
		  $path = pathinfo( $checkname );
		  $filename = $path['filename'] . '_' . $i;
      $checkname = trailingslashit( $lg_gallery->root . $this->curdir ) . $filename . '.' . $path['extension'];
      $i++;
		}    
    $pathtofile = $checkname;
		$moved = move_uploaded_file( $html_upload, $pathtofile ); // move uploaded file to folder
    
    if ( !$moved ) {
		  $moved = copy( $html_upload, $pathtofile ); // copy duplicate (numbered) name file to new name
		}
    
		if ( !$moved ) {
      $lg_gallery->options_message( sprintf( __( "Couldn't upload your file to %s.", $lg_gallery->text_domain ), $pathtofile ) );
		} else {
			$stat = stat( dirname( $pathtofile ));
			$perms = $stat['mode'] & 0000666;
			@chmod($pathtofile, $perms);
			@unlink($html_upload);
		}
    
		if ( $duplicate_file ) {
		  ?>
			<h2><?php _e( 'Duplicate File?', $lg_gallery->text_domain ); ?></h2>
			<div id="message" class="error">
        <p>
        <?php printf( __( 'The filename "%s" already exists', $lg_gallery->text_domain ), $image_name ); ?>
        </p>
      </div>
      <div class="wrap">
        <p>
          <?php	printf( __( "Filename '%1\$s' moved to '%2\$s'", $lg_gallery->text_domain), basename( $html_upload ), basename( $pathtofile ) ); ?>
        </p>
        <form action="<?php echo esc_attr( 'admin.php?page=lazyest-filemanager&amp;upload=html&amp;folder=' . lg_nice_link( $this->curdir ) ); ?>" method="post" enctype="multipart/form-data">
          <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo wp_max_upload_size(); ?>" />
          <input type="hidden" name="newtype" value="<?php echo $image_type; ?>" />
          <input type="hidden" name="newname" value="<?php echo $image_name; ?>" />
          <input type="hidden" name="newsize" value="<?php echo $image_size; ?>" />
          <input type="hidden" name="html_upload" value=" $pathtofile " />
          <?php  _e( 'Alternate name:' ) ?><br />
          <input type="text" name="newname" size="30" class="uploadform" value="<?php echo basename( $pathtofile ); ?> " /><br />
          <p class="submit">
            <input style="width:128px" type="submit" name="submit" value="<?php _e( 'Rename', $lg_gallery->text_domain); ?>" class="button-secondary" />
          </p>
        </form><br class="clear" />
      </div>
      <?php
			return;
		}
		$piece_of_code = "[lg_image folder=\"$this->curdir\" image=\"$image_name\"]";
		$piece_of_code = esc_html( $piece_of_code );
    ?>
      <div id="message" class="updated fade">
        <p>
		      <?php printf( __('Your file <code>%s</code> was uploaded successfully!', $lg_gallery->text_domain ), $image_name ); ?>
        </p>
        <p>
          <?php echo _e( 'Here is the code to display it in your posts:', $lg_gallery->text_domain); ?><code><?php echo  $piece_of_code; ?></code>
        </p>
        <br class="clear" />
        <table width="50%">
          <thead>
            <tr>
              <td colspan="2"><?php _e( 'Image Details', $lg_gallery->text_domain ); ?></td>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td><strong><?php _e( 'Name:', $lg_gallery->text_domain ); ?></strong></td>
              <td><?php echo $image_name; ?></td>
            </tr>
            <tr>
              <td><strong><?php _e( 'Size:', $lg_gallery->text_domain ); ?></strong></td>
              <td><?php echo round( $image_size / 1024, 2 ); ?><abbr title="Kilobyte">KB</abbr></td>
            </tr>
            <tr>
              <td><strong><?php _e( 'Type:', $lg_gallery->text_domain ); ?></strong></td>
              <td><?php echo $image_type ?></td>
            </tr>
          </tbody>
        </table>
        <table class="form-table">
          <tr>
            <td style="width:30%"><a class="button-secondary" href="#html_upload-ui"><?php _e( 'Upload another', $lg_gallery->text_domain ); ?></a></td>
            <td>&nbsp;</td>
          </tr>
        </table>
        <br /><br class="clear" />
      </div>
      <?php
		return;  	
  }
  
  /**
   * LazyestAdminFolder::save_edits()
   * 
   * @return void
   */
  function save_edits() {
    global $lg_gallery, $wp_roles;
    $this->open(); 
  	$this->caption = $_POST['folder_caption'];
  	$this->description =  $_POST['fdescription'];
  	$folder_roles = array();
  	if ( !isset($_POST['everyone_checkbox'] ) ) { 
  		$folder_roles[] = 'everyone';
  		foreach( $wp_roles->role_names as $role ) {
  			$folder_roles[] = $role;		
  		}
  	}		
  	$keys = array_keys($_POST);
  	foreach ( $keys as $key ) {
  		$is_role = strpos( $key, 'chk_' );
  		if ( !( $is_role === false ) ) { 
  			if ( isset( $_POST[$key] ) ) $folder_roles[] = $_POST[$key];
  		}
  	}
  	$this->roles = $folder_roles;
    $this->visibility = ( isset( $_POST['visible_checkbox'] ) ) ? 'hidden' : 'visible';
    $this->change();
    $this->load();
  	for ( $i = 0; $i != count( $this->list ); $i++ ) {
  		// prepare the strings to be written
      $image = $this->list[$i];
  		$form_value = $image->form_name();
      $image->caption = $_POST[$form_value];     	
      $image->description = $_POST["desc_" . $form_value];
      $image->index = $_POST["index_" . $form_value];
  	}        
  	$success = $this->save();
 
    $message = ( $success ) ? __( 'Image data saved. Continue editing below', $lg_gallery->text_domain ) : __( 'Could not save Image data. Please check your file permissions', $lg_gallery->text_domain );
    $lg_gallery->options_message( $message, $success );    
  }
  
  /**
   * LazyestAdminFolder::sort_subfolders()
   * 
   * @return void
   */
  function sort_subfolders() {
  	global $lg_gallery;
    $subfolders = $this->subfolders( 'hidden' );
  	for ( $i = 0; $i != count( $subfolders ); $i++ ) {
      $folder = $subfolders[$i]; 
  		$folder_id = $folder->form_name();
  		$index_name = "index_" . $folder_id;
  		$folder->order = $_POST[$index_name];
  		$visibility_name =  "visible_" . $folder_id ;
      $folder->visibility = ( isset( $_POST[$visibility_name] ) ) ? 'hidden' : 'visible';
  		$success = $folder->change();
      if ( !$success ) {
        break;
      }
  	}
    $message = ( $success ) ? __( 'Subfolders sorted. Continue editing below', $this->text_domain ) : __( 'Lazyest Gallery could not save your folders.', $this->text_domain );     
    $lg_gallery->options_message( $message, $success );
  }
  
  function delete_file() {
    global $lg_gallery;
    $delete_this = $_GET['file_to_delete'];
    $cache = ( isset( $_GET['cache'] ) ) ? $_GET['cache'] : '';
    $waste_it = $lg_gallery->root . $this->curdir . $delete_this;
    if ( file_exists( $waste_it ) ) {
      if ( !is_dir( $waste_it ) ) { // delete an image
        if ( isset( $lg_gallery->commentor ) ) {
          $lg_gallery->commentor->remove_comments( $this->curdir . $adelete_this ); 
        }
        $success = @unlink(  $waste_it );
        $message = ( $success ) ? __( ' Image deleted successfully', $lg_gallery->text_domain ) : __( ' Cannot delete file, maybe it has already been deleted or have wrong permissions', $lg_gallery->text_domain );    		
    	} else { // delete cache
         if ( '' != $cache ) {
          $success = $lg_gallery->clear_directory( $waste_it );
          $message = ( $success ) ? __( ' Cache deleted successfully', $lg_gallery->text_domain )  : __( ' Cannot delete cache, maybe it has already been deleted or have wrong permissions',  $lg_gallery->text_domain ) ; 
          }
   		}
   	} else { // file does not exist 
      if ( '' != $cache ) { // but cache should be deleted
        $success = true;
        $message = $delete_this .  __( ' Cache deleted successfully', $lg_gallery->text_domain );
      } else { // file not found. deleted in other session?
        $succes = false;
        $message = $delete_this . __( ' Does not exist', $lg_gallery->text_domain );
      } 
    }  
    $lg_gallery->options_message( $message, $success );
  }
  
    
} // LazyestAdminFolder
?>