<?php

/**
 * Sidebar Widgets for Lazyest Gallery
 * 
 * @package Lazyest-Gallery  
 * @author Marcel Brinkkemper
 * @copyright 2008-2010 Marcel Brinkkemper
 */

add_action( 'widgets_init', 'lg_lazyest_widgets' );

function lg_lazyest_widgets() {

  if ( ! function_exists('register_sidebar_widget') )
    return;

  function lg_widget_list_folders( $args ) {
    extract( $args );
    $options = get_option( 'widget_lg_list_folders' );
    $title = $options['title'];
    if ( empty($title) )
      $title = __( 'LG Folders' );
    echo $before_widget . $before_title . $title . $after_title;
    lg_list_folders( '' );
    echo $after_widget;
  }

  function lg_widget_list_folders_control() {
    $options = $newoptions = get_option( 'widget_lg_list_folders' );
    if ( $_POST["lg_list_folders-submit"] ) {
      $newoptions['title'] = strip_tags( stripslashes($_POST["lg_list_folders-title"]) );
    }
    if ( $options != $newoptions ) {
      $options = $newoptions;
      update_option( 'widget_lg_list_folders', $options );
    }
    $title = attribute_escape( $options['title'] );

?>
			<p><label for="lg_list_folders-title"><?php

    _e( 'Title:' );

?> <input class="widefat" id="lg_list_folders-title" name="lg_list_folders-title" type="text" value="<?php

    echo $title;

?>" /></label></p>
			<input type="hidden" id="lg_list_folders-submit" name="lg_list_folders-submit" value="1" />
<?php

  }

  function lg_widget_random_image( $args ) {
    extract( $args );
    $options = get_option( 'widget_lg_random_image' );
    $title = $options['title'];
    $count = $options['count'];
    $folder = $options['folder'];
    $sub = isset( $options['subfolders'] );
    if ( empty($count) )
      $count = '1';
    if ( empty($title) )
      $title = __( 'LG Random Image' );
    echo $before_widget . $before_title . $title . $after_title;
    lg_random_image( '', $count, $folder, $sub );
    echo $after_widget;
  }

  function lg_widget_random_image_control() {
    global $lg_gallery;
    $options = get_option( 'widget_lg_random_image' );
    if ( $_POST["lg_random_image-submit"] ) {
      $options['title'] = strip_tags( stripslashes($_POST["lg_random_image-title"]) );
      $options['count'] = $_POST['lg_random_image-count'];
      $options['folder'] = $_POST['lg_random_image-folder'];
      $options['subfolders'] = $_POST['lg_random_image-sub'];
      if ( $options['folder'] == '' )
        $options['subfolders'] = 'on';
      update_option( 'widget_lg_random_image', $options );
    }

    $title = attribute_escape( $options['title'] );
    $count = $options['count'];
    if ( $count == '' )
      $count = '1';
    $folder = $options['folder'];
    $sub = $options['subfolders'] ? 'checked="checked"' : '';

    $dirlist = $lg_gallery->folders( 'subfolders', 'visible' );

?>
			<p><label for="lg_random_image-title"><?php

    _e( 'Title:', $lg_gallery->text_domain );

?> <input class="widefat" id="lg_random_image-title" name="lg_random_image-title" type="text" value="<?php

    echo $title;

?>" /></label></p>
			<p><label for="lg_random_image-count"><?php

    _e( 'Number of Images:', $lg_gallery->text_domain );

?> <input class="widefat" id="lg_random_image-count" name="lg_random_image-count" type="text" size="2" value="<?php

    echo $count;

?>" /></label></p>
			<p><label for="lg_random_image-folder"><?php

    _e( 'Folder', $lg_gallery->text_domain );

?> <select id="lg_random_image-folder" name="lg_random_image-folder">
				<option value="" <?php

    if ( $folder == '' )
      echo 'selected="selected"';

?> ><?php

    _e( '(all)', $lg_gallery->text_domain );

?></option>
				<?php

    foreach ( $dirlist as $dir ) {
      echo '<option value="' . $dir->curdir . '"';
      if ( $folder == $dir->curdir )
        echo 'selected="selected"';
      echo ' >' . $dir->curdir . '</option>';
    }

?>
			</select></label></p>
			<p><label for="lg_random_image-sub"><?php

    _e( 'Include Sub Folders', $lg_gallery->text_domain );

?> <input type="checkbox" id="lg_random_image-sub" name="lg_random_image-sub" <?php

    echo $sub;

?> /></label></p>
			<input type="hidden" id="lg_random_image-submit" name="lg_random_image-submit" value="1" />
<?php
  
  }

  function lg_widget_slide_show( $args ) {
    extract( $args );
    $options = get_option( 'widget_lg_slide_show' );
    $title = $options['title'];
    $count = $options['count'];
    $display = $options['display'];
    $folder = $options['folder'];
    $sub = $options['subfolders'];
    if ( empty($count) )
      $count = '1';
    if ( empty($title) )
      $title = __( 'LG Slide Show' );
    echo $before_widget . $before_title . $title . $after_title;
    lg_random_slideshow( '', $count, $display, $folder, $sub == 'on' );
    echo $after_widget;
  }

  function lg_widget_slide_show_control() {
    global $lg_gallery;
    $options = get_option( 'widget_lg_slide_show' );
    if ( $_POST["lg_slide_show-submit"] ) {
      $options['title'] = strip_tags( stripslashes($_POST["lg_slide_show-title"]) );
      $options['count'] = $_POST['lg_slide_show-count'];
      $options['display'] = $_POST['lg_slide_show-time'];
      $options['folder'] = $_POST['lg_slide_show-folder'];
      $options['subfolders'] = $_POST['lg_slide_show-sub'];
      if ( $options['folder'] == '' )
        $options['subfolders'] = 'on';
      update_option( 'widget_lg_slide_show', $options );
    }

    $title = attribute_escape( $options['title'] );
    $count = $options['count'];
    $display = $options['display'];
    if ( $count == '' )
      $count = '2';
    if ( $display == '' )
      $display = '5';
    $folder = $options['folder'];
    $sub = $options['subfolders'] ? 'checked="checked"' : '';
    $dirlist = $lg_gallery->folders( 'subfolders', 'visible' );

?>
			<p><label for="lg_slide_show-title"><?php

    _e( 'Title:' );

?> <input class="widefat" id="lg_slide_show-title" name="lg_slide_show-title" type="text" value="<?php

    echo $title;

?>" /></label></p>
			<p><label for="lg_slide_show-count"><?php

    _e( 'Number of Images:' );

?> <input class="widefat" id="lg_slide_show-count" name="lg_slide_show-count" type="text" size="2" value="<?php

    echo $count;

?>" /></label></p>
			<input class="widefat" id="lg_slide_show-time" name="lg_slide_show-time" type="hidden" size="2" value="<?php

    echo $display;

?>" /></label></p>	
			<p><label for="lg_slide_show-folder"><?php

    _e( 'Folder', $lg_gallery->text_domain );

?> <select id="lg_slide_show-folder" name="lg_slide_show-folder">
				<option value="" <?php

    if ( $folder == '' )
      echo 'selected="selected"';

?> ><?php

    _e( '(all)', $lg_gallery->text_domain );

?></option>
				<?php

    foreach ( $dirlist as $dir ) {
      echo '<option value="' . $dir->curdir . '"';
      if ( $folder == $dir->curdir )
        echo 'selected="selected"';
      echo ' >' . $dir->curdir . '</option>';
    }

?>
			</select></label></p>
			<p><label for="lg_slide_show-sub"><?php

    _e( 'Include Sub Folders', $lg_gallery->text_domain );

?> <input type="checkbox" id="lg_slide_show-sub" name="lg_slide_show-sub" <?php

    echo $sub;

?> /></label></p>
			
			<input type="hidden" id="lg_slide_show-submit" name="lg_slide_show-submit" value="1" />
<?php

  }

  $widget_ops = array( 'classname' => 'lg_list_folders', 'description' => __("A list of all your Lazyest Gallery Folders",
    lg_text_domain) );
  wp_register_sidebar_widget( 'lg-list-folders', __('LG List Folders'),
    'lg_widget_list_folders', $widget_ops );
  wp_register_widget_control( 'lg-list-folders', __('LG List Folders'),
    'lg_widget_list_folders_control' );

  $widget_ops = array( 'classname' => 'lg_random_image', 'description' => __("Random Images from your Lazyest Gallery",
    lg_text_domain) );
  wp_register_sidebar_widget( 'lg-random-image', __('LG Random Image'),
    'lg_widget_random_image', $widget_ops );
  wp_register_widget_control( 'lg-random-image', __('LG Random Image', $lg_gallery->text_domain),
    'lg_widget_random_image_control' );

  $widget_ops = array( 'classname' => 'lg-slide-show', 'description' => __("Slide Show of Thumbnails from your Lazyest Gallery",
    lg_text_domain) );
  wp_register_sidebar_widget( 'lg-slide-show', __('LG Slide Show'),
    'lg_widget_slide_show', $widget_ops );
  wp_register_widget_control( 'lg-slide-show', __('LG Slide Show', $lg_gallery->text_domain),
    'lg_widget_slide_show_control' );

}

?>